<?php
if (!session_id()) {
	session_start();
}

/**
 * Understrap functions and definitions
 *
 * @package understrap
 */

/**
 * Theme setup and custom theme supports.
 */
require get_template_directory() . '/inc/setup.php';

/**
 * Register widget area.
 *
 * @link http://codex.wordpress.org/Function_Reference/register_sidebar
 */
require get_template_directory() . '/inc/widgets.php';

/**
 * Load functions to secure your WP install.
 */
require get_template_directory() . '/inc/security.php';

/**
 * Enqueue scripts and styles.
 */
require get_template_directory() . '/inc/enqueue.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/template-tags.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/inc/pagination.php';

/**
 * Custom functions that act independently of the theme templates.
 */
require get_template_directory() . '/inc/extras.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/customizer.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/inc/custom-comments.php';

/**
 * Load Jetpack compatibility file.
 */
require get_template_directory() . '/inc/jetpack.php';

/**
 * Load custom WordPress nav walker.
 */
require get_template_directory() . '/inc/bootstrap-wp-navwalker.php';

/**
 * Load WooCommerce functions.
 */
require get_template_directory() . '/inc/woocommerce.php';

/**
 * Load Editor functions.
 */
require get_template_directory() . '/inc/editor.php';



require get_template_directory() . '/inc/post_types/CPT.php';
require get_template_directory() . '/inc/post_types/feature.php';
// require get_template_directory() . '/inc/post_types/event.php';

if( function_exists('acf_add_options_page') ) {
	acf_add_options_page(array(
		'page_title' 	=> 'General Settings',
		'menu_title'	=> 'General Settings',
		'menu_slug' 	=> 'general-settings',
		'capability'	=> 'edit_posts',
		'redirect'		=> false
	));
}

// add_filter('acf/settings/show_admin', 'my_acf_show_admin');

// function my_acf_show_admin( $show ) {
// 	return false;
// }

define( 'LAMBDA_ENDPOINT', 'https://ck0jmpuarf.execute-api.eu-west-1.amazonaws.com/prod' );
define( 'PDF_ROOT', 'https://d3vyebc0yrz32p.cloudfront.net/' );
define( 'REACT_APP', 'https://d42569249szls.cloudfront.net/' );

define( 'API_ENDPOINT', 'https://api.e-slides.net/api' );
// define( 'API_ENDPOINT', 'http://localhost:8000/api' );

define( 'AUDIENCE_SITE', 'https://audience.e-slides.net/' );
// define( 'AUDIENCE_SITE', 'http://localhost:5000/' );

function fetch_event_data( $query ) {
	// if("event" == $query->query['post_type']) {
		// print_r($query->query['name']);
		// return;
	// }
}
// add_action( 'pre_get_posts', 'fetch_event_data' );

add_filter( 'query_vars', 'addnew_query_vars', 10, 1 );
function addnew_query_vars($vars)
{   
	$vars[] = 'event_id';
	$vars[] = 'event';
	$vars[] = 'presentation_id';
	$vars[] = 'no_cache';
	$vars[] = 'synopsis';
	$vars[] = 'session';
	$vars[] = 'viewmode';
	return $vars;
}

// flush_rewrite_rules(true);
