<?php
/**
 * Template Name: Events
 *
 * @package understrap
 */

if(WPGlobus::Config()->language === 'fr') {
	setlocale(LC_TIME, 'fr_FR');
}

get_header();
$event_id = get_query_var( "event", false);
$event_id = get_query_var( "event_id", $event_id);
$presentation_id = get_query_var( "presentation_id", false);
$no_cache = get_query_var( "no_cache", false);

$page_synopsis = get_query_var( "synopsis", false);
$page_session = get_query_var( "session", false);
$page_schedule = !($page_synopsis || $page_session);

$sidebar_pos = get_theme_mod('understrap_sidebar_position');

if($_POST['password']) {
	$_SESSION['password_' . $event_id] = $_POST['password'];
}

function printHumanTime($time) {
	return intdiv($time, 60) . ":" . sprintf('%02d', $time % 60);
}

function custom_compare($a, $b)
{
	$atime = explode(":", $a->time);
	$btime = explode(":", $b->time);
	$ats = strtotime($a->date) + ($atime[0] * 60 * 60) + ($atime[1] * 60);
	$bts = strtotime($b->date) + ($btime[0] * 60 * 60) + ($btime[1] * 60);

	return $ats > $bts;
}

function promptForPassword() {
?>
	<script>
		var password = prompt("<?php if(403 == $json->statusCode) { echo 'Incorrect password. '; } ?>Please enter the event password.");
		if(password) {
			var form = jQuery(document.createElement('form'));
			jQuery(form).attr("action", document.location.href);
			jQuery(form).attr("method", "POST");

			var input = jQuery("<input>")
				.attr("type", "hidden")
				.attr("name", "password")
				.val(password);

			jQuery(form).append(jQuery(input));
			form.appendTo(document.body)
			jQuery(form).submit();
		}
	</script>
	<p>You need a password to access this event. Please reload the page and enter the password in the prompt.</p>
<?php
}
?>
<style type="text/css">
	/* DO NOT MOVE TO SCSS! */
	.navbar {
		display: none;
	}
</style>

<?php
	if($event_id && !$presentation_id) {
		if($no_cache || false === ($event = get_transient("event-" . $event_id) ) ) {
			$response = wp_remote_get(
				LAMBDA_ENDPOINT . '/schedule/' . $event_id,
				array(
					'body' => array(
						'password' => $_SESSION['password_' . $event_id]
					)
				)
			);
			// $response = wp_remote_get( API_ENDPOINT . '/v2/public-event/' . $event_id );
			$body = wp_remote_retrieve_body( $response );
			$json = json_decode($body);
			if( 201 == $json->statusCode ) {
				set_transient("event-" . $event_id, $json->data, 600);
				$event = $json->data;
			} else if( 401 == $json->statusCode || 403 == $json->statusCode ) {
				promptForPassword();
				return;
			} else {
				echo "There was an error. Please retry";
			}
		} else {
			// $data has been set and is populated with the contents of the transient
		}

		if($event->event->displayPassword !== $_SESSION['password_' . $event_id]) {
			promptForPassword();
			return;
		}

		$sbg = $event->event->schedule_background_color;
		$stg = $event->event->schedule_text_color;

		$hasForum = $event->event->forum && $event->event->audience_site_password;
		$hasQuiz = $event->event->quiz && $event->event->audience_site_password;
		?>
<script>
function __reactEngage(pid, presentationName, tab) {
	// console.log(pid, presentationName, tab);
	reactComponents.engagement.setState({
		eventId: "<?php echo $event->event->_id; ?>",
		show: true,
		locale: 'en',
		forum: <?php echo $event->event->forum ? 'true' : 'false'; ?>,
		quiz: <?php echo $event->event->quiz ? 'true' : 'false'; ?>,
		primary: '<?php echo $sbg; ?>',
		primaryText: '<?php echo $stg; ?>',

		presentationId: pid,
		presentationName: presentationName,
		tab: tab
	})
}
</script>

<style type="text/css">
	/* html {
		--primary: <?php echo $sbg; ?>;
		--primary-text: <?php echo $stg; ?>;
	} */

	.nav-pills-custom .nav-item .nav-link.active,
	.nav-pills-custom .nav-item .nav-link:hover,
	.schedule-date,
	.session-info,
	.room-name-synopsis {
		background: <?php echo $sbg; ?>;
		color:  <?php echo $stg; ?>;
	}
	.room-name-synopsis h3 {
		color:  <?php echo $stg; ?>;
	}
	.select2-container {
		width: 100%;
	}
	@media (min-width: 1920px) {
		.container {
				max-width: 1570px;
		}
	}
</style>

		<div class="container">
			<div class="row">
				<div class="col-md-12 text-center">
					<?php echo $event->event->ad; ?>
				</div>
			</div>
		</div>
		<?php
	}
?>

<div class="wrapper pad-top-0" id="page-wrapper">
	<div class="" id="content" tabindex="-1">
		<?php if(!$event_id) { ?>
			<div class="container">
				<div class="row">
					<div class="col-md-12">
						<?php get_template_part( 'loop-templates/content', 'page' ); ?>
					</div>
				</div>
			</div>
		<?php } ?>

		<?php while ( have_posts() ) : the_post();?>
			<?php
				if(!$event_id) {
					if($no_cache || false === ($events = get_transient("events") ) ) {
						$response = wp_remote_get( API_ENDPOINT . '/events' );
						$body = wp_remote_retrieve_body( $response );
						$json = json_decode($body);

						if( 201 == $json->statusCode ) {
							set_transient("events", $json->data, 600);
							$events = $json->data;
						} else {
							echo "There was an error. Please retry";
						}
					} else {
						// $events has been set and is populated with the contents of the transient
					}
					?>
					<div class="container">
						<div class="row">
							<?php
								foreach($events as $event) {
								?>
									<div class="col-md-4 col-sm-6 text-center">
										<div class="event-tile bg-ee">
											<h4><?php echo $event->name; ?></h4>
											<a href="?event=<?php echo $event->slug ? $event->slug : $event->_id; ?>">
												<div style="height: 200px; display: flex; align-items: center; justify-content: center;">
													<img src="<?php echo $event->logo ?
														str_replace("http://eslides-staging-media.s3-website-eu-west-1.amazonaws.com", "https://d3os20cgecg1yy.cloudfront.net", $event->logo) :
														"https://www.e-slides.net/wp-content/uploads/2017/10/logo.png";
													?>" alt="<?php echo $event->name; ?>" class="img-fluid" style="max-height: 200px; max-width: 300px;">
												</div>
											</a>
											<b><?php echo $event->venue; ?></b><br />
											<?php
												echo utf8_encode(strftime("%e %B %Y", strtotime($event->start)));
												if( strtotime($event->start) != strtotime($event->end) ) {
													echo get_field('event_' . WPGlobus::Config()->language . '_to', 'option') . utf8_encode(strftime("%e %B %Y", strtotime($event->end)));
												}
											?>
										</div>
									</div>
								<?php
								}
							?>
						</div>
					</div>
					<?php
				} else if(!$presentation_id) {
					if($no_cache || false === ($event = get_transient("event-" . $event_id) ) ){
						$response = wp_remote_get(
							LAMBDA_ENDPOINT . '/schedule/' . $event_id,
							array(
								'body' => array(
									'password' => $_SESSION['password_' . $event_id]
								)
							)
						);
// 						$response = wp_remote_get( API_ENDPOINT . '/v2/public-event/' . $event_id );
						$body = wp_remote_retrieve_body( $response );
						$json = json_decode($body);

						if( 201 == $json->statusCode ) {
							set_transient("event-" . $event_id, $json->data, 600);
							$event = $json->data;
						} else {
							echo "There was an error. Please retry";
						}
					} else {
						// $data has been set and is populated with the contents of the transient
					}

					// echo "<pre>";
					// print_r($event);
					// echo "</pre>";

					?>
			
					<?php	
						$datesData = $event->dates;
						// $presentations = $event->presentations;
						// usort($presentations, "custom_compare");

						$filters = array(
							"speakers", "rooms", "types", "associations", "dates"
						);

						$speakers = array();
						$rooms = array();
						$themes = array();
						$themecolors = array();
						$types = array();
						$associations = array();
						$dates = array();

						foreach($datesData as $date) {
							foreach($date->rooms as $roomData) {
								foreach($roomData->presentations as $presentation) {
									$speakers[$presentation->speaker_info->_id] = $presentation->speaker_info->title . " " . $presentation->speaker_info->firstName . " |" . $presentation->speaker_info->lastName;
									$rooms[$presentation->room_info->_id] = $presentation->room_info->name;
									$themes[$presentation->color_info->_id] = $presentation->color_info->name;
									$themecolors[$presentation->color_info->_id] = $presentation->color_info->color;
									$types[$presentation->type_info->_id] = $presentation->type_info->name;
									$associations[$presentation->association_info->_id] = $presentation->association_info->name;
									$dates[substr($presentation->date, 0, 10)] = utf8_encode(strftime("%A %e %B %Y", strtotime($presentation->date)));
								}
							}
						}
					?>
					<header class="page-header">
						<div class="event-header">
							<div class="container">
								<div class="row row align-items-center">
									<div class="col-md-8">
										<img src="<?php echo $event->event->logo ?
											str_replace("http://eslides-staging-media.s3-website-eu-west-1.amazonaws.com/", "https://d14dvar9q0pvq6.cloudfront.net/fit-in/180x80/filters:fill(ffffff)/", $event->event->logo) :
											"https://www.e-slides.net/wp-content/uploads/2017/10/logo.png";
										?>" alt="<?php echo $event->event->name; ?>" class="img-fluid" style="max-height: 120px; max-width: 180px;">
									</div>
									<div class="col-md-4">
										<div class="location-event text-right">
											<h4 style="margin-bottom: 0px"><?php echo $event->event->name; ?></h4>
											<b><?php if($event->event->venue) { echo $event->event->venue; } ?></b>
											<span><?php
												echo utf8_encode(strftime("%e %B %Y", strtotime($event->event->start)));
												if( strtotime($event->event->start) != strtotime($event->event->end) ) {
													echo get_field('event_' . WPGlobus::Config()->language . '_to', 'option') . utf8_encode(strftime("%e %B %Y", strtotime($event->event->end)));
												}
											?></span>
										</div>
									</div>
								</div>
							</div>
						</div>
					</header>

					<style type="text/css">
						<?php foreach($themes as $key => $val) { ?>
							li[id*="-filter-<?php echo $key; ?>"]::before, li.select2-results__option--highlighted[id*="-filter-<?php echo $key; ?>"]::before {
								background-color: <?php echo $themecolors[$key]; ?>;
							}
						<?php } ?>
					</style>
					
					<br />
					<div class="container">
						<div class="row align-items-center m-t-40">
							<div class="col-md-9">
								<ul class="nav nav-pills-custom">
									<li class="nav-item">
										<a class="nav-link<?php if($page_schedule) { ?> active<?php } ?>" href="?event=<?php echo $event->event->slug ? $event->event->slug : $event->event->_id; ?>"><?php the_field('event_' . WPGlobus::Config()->language . '_schedule', 'option') ?></a>
									</li>
									<li class="nav-item">
										<a class="nav-link<?php if($page_synopsis) { ?> active<?php } ?>" href="?event=<?php echo $event->event->slug ? $event->event->slug : $event->event->_id; ?>&synopsis=true"><?php the_field('event_' . WPGlobus::Config()->language . '_synopsis', 'option') ?></a>
									</li>
									<?php if(count($event->dates[0]->sessions) > 1) { ?>
										<li class="nav-item">
											<a class="nav-link<?php if($page_session) { ?> active<?php } ?>" href="?event=<?php echo $event->event->slug ? $event->event->slug : $event->event->_id; ?>&session=true"><?php the_field('event_' . WPGlobus::Config()->language . '_session', 'option') ?></a>
										</li>
									<?php } ?>
									<!--
									<li class="nav-item">
										<a class="nav-link" href="#" onclick="alert('Coming soon')">Download PDF</a>
									</li>
									-->

									<?php if(!$page_session) { ?>
										<li class="nav-item">
											<a href="#collapseFilters" class="nav-link" data-toggle="collapse" data-target="#collapseFilters" aria-expanded="false" aria-controls="collapseFilters">
											<?php the_field('event_' . WPGlobus::Config()->language . '_filter_presentations', 'option') ?>
											</a>
										</li>
									<?php } ?>
									<!--
									<li class="nav-item">
										<a class="nav-link" href="#"><i class="fas fa-calendar-alt"></i> My Program</a>
									</li>
									-->
								</ul>
							</div>
							<?php if(!$page_session) { ?>
								<!--
								<div class="col-md-2 text-right">
									<b><?php the_field('filter_theme'); ?></b>
								</div>
								-->
								<div class="col-md-3">
									<?php
										if(count($themes) > 1) {
										?>
										<select multiple="multiple" class="select2-presentation-filter form-control">
											<?php foreach($themes as $key => $val ):  ?>
												<option value="filter-<?php echo $key; ?>"><?php echo $val ? $val : "No Theme"; ?></option>
											<?php endforeach; ?>
										</select>
									<?php
									} ?>
								</div>
							<?php } ?>
						</div>

						<?php if(!$page_session) { ?>
							<div class="row">
								<div class="col">
									<div class="card">
										<div id="collapseFilters" class="collapse" aria-labelledby="headingOne">
											<button type="button" class="close" aria-label="Close" data-toggle="collapse" href="#collapseFilters">
												<span aria-hidden="true">&times;</span>
											</button>
											<div class="card-block">
												<div class="row">
													<?php
													foreach($filters as $filter) { 
													if(count(array_filter($$filter)) > 0) {
													?>
													<div class="col-md-6">
														<div class="row m-b-20 no-gutters">
															<div class="col-sm-3">
																<span class="f-label"><?php the_field('event_' . WPGlobus::Config()->language . '_filter_' . $filter, 'option'); ?></span>
															</div>
															<div class="col-sm-9">
																<select multiple="multiple" class="form-control sel2-filters filter-special-<?php echo $filter; ?>" style="width: 100%; margin-bottom: 20px;">
																<?php
																	foreach(array_filter($$filter) as $key => $val) {
																		if($filter === 'speakers') {
																			?>
																				<option value="filter-<?php echo $key; ?>" data-lastname="<?php echo explode("|", $val)[1]; ?>"><?php echo str_replace("|", "", $val); ?></option>
																			<?php
																		} else {
																			?>
																				<option value="filter-<?php echo $key; ?>"><?php echo $val; ?></option>
																			<?php
																		}
																	}
																?>
																</select>
															</div>
														</div>
													</div>
												<?php }
												} ?>
												<div class="col-md-6">
													<div class="row">
														<div class="col-sm-3">
															<b><?php the_field('event_' . WPGlobus::Config()->language . '_filter_type', 'option'); ?></b>
														</div>
														<div class="col-sm-9">
															<label>
																<input type="radio" value="union" name="ppt-filter-type" checked /> <?php the_field('event_' . WPGlobus::Config()->language . '_filter_union', 'option'); ?>
															</label>
															<label>
																<input type="radio" value="intersection" name="ppt-filter-type" /> <?php the_field('event_' . WPGlobus::Config()->language . '_filter_intersection', 'option'); ?>
															</label>
														</div>
													</div>
												</div>
												<div class="col-md-12">
													<label>
														<input type="checkbox" value="true" name="ppt-status-recording" /> Presentations being recorded currently
													</label>
												</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</div>
						<?php } ?>
					</div>
					<div class="container">
						<br />
					<?php
						if($page_synopsis) {
							// Synopsis page 
							include('content-synopsis.php');
						} else if ($page_schedule) {
							// Schedule page
							include('content-schedule.php');
						} else if ($page_session) {
							// Session page
							include('content-session.php');
						}
				} else {
					if($no_cache || false === ($event = get_transient("presentation-" . $presentation_id) ) ){
						$response = wp_remote_get(
							// API_ENDPOINT . '/public-event/' . $event_id,
							LAMBDA_ENDPOINT . '/presentation/' . $event_id,
							array(
								'body' => array(
									'presentation_id' => $presentation_id,
									'password' => $_SESSION['password_' . $event_id]
								)
							)
						);
						$body = wp_remote_retrieve_body( $response );
						$json = json_decode($body);

						if( 201 == $json->statusCode ) {
							set_transient("presentation-" . $presentation_id, $json->data, 600);
							$event = $json->data;
						} else if( 401 == $json->statusCode || 403 == $json->statusCode ) {
							promptForPassword();
							return;
						} else {
							echo "There was an error. Please retry";
						}
					} else {
						// $event has been set and is populated with the contents of the transient
					}

					if($event->event->displayPassword !== $_SESSION['password_' . $event_id]) {
						promptForPassword();
						return;
					}

					$presentation = $event->presentations[0];
					?>
					<script>
						var __slides = <?php echo json_encode($presentation->thumbnails); ?>;
					</script>
					<?php
					include('content-video.php');
				}
			?>
		<?php endwhile; // end of the loop. ?>
	</div><!-- #primary -->
</div><!-- Container end -->

<div class="container">
	<div class="row">
		<div class="col-md-12">
			<a href="<?php echo get_site_url(); ?>"><img src="<?php echo get_site_url(); ?>/wp-content/uploads/2017/10/logo.png" alt="eSlides" style="height: 40px" /></a>
		</div>
	</div>
</div>
<div id="engagement-embed"></div>
<script>
	jQuery(window).load(function() {
		reactComponents = {
			engagement: ReactDOM.render(
				window.rawReactComponents.engagement(),
				document.getElementById('engagement-embed')
			)
		} 

		reactComponents.engagement.setState({
			primary: '<?php echo $sbg; ?>',
			primaryText: '<?php echo $stg; ?>'
		})
	})
</script>

<script type="text/javascript">
	jQuery(document).ready(function() {
    jQuery('.select2-presentation-filter').select2({
      placeholder: "<?php the_field('event_' . WPGlobus::Config()->language . '_filter_themes', 'option'); ?>",
      allowHtml: true,
      closeOnSelect : false,
      allowClear: true,
      sorter: function(data) {
        /* Sort data using lowercase comparison */
        return data.sort(function (a, b) {
            a = a.text.toLowerCase();
            b = b.text.toLowerCase();
            if (a > b) {
                return 1;
            } else if (a < b) {
                return -1;
            }
            return 0;
        });
      }
    }).on('change.select2', function (e) {
      // Do something
      doFilter();
    });;

    jQuery('.sel2-filters:not(".filter-special-dates,.filter-special-speakers")').select2({
      closeOnSelect : false,
      sorter: function(data) {
        /* Sort data using lowercase comparison */
        return data.sort(function (a, b) {
            a = a.text.toLowerCase();
            b = b.text.toLowerCase();
            if (a > b) {
              return 1;
            } else if (a < b) {
              return -1;
            }
            return 0;
        });
      }
    }).on('change.select2', function (e) {
      // Do something
      doFilter();
    });

    jQuery('.filter-special-speakers').select2({
      closeOnSelect : false,
      sorter: function(data) {
        /* Sort data using lowercase comparison */
        return data.sort(function (a, b) {
            a = jQuery(a.element).data('lastname').toLowerCase();
            b = jQuery(b.element).data('lastname').toLowerCase();
            if (a > b) {
              return 1;
            } else if (a < b) {
              return -1;
            }
            return 0;
        });
      }
    }).on('change.select2', function (e) {
      // Do something
      doFilter();
    });

    jQuery('.filter-special-dates').select2({
      closeOnSelect : false
    }).on('change.select2', function (e) {
      // Do something
      doFilter();
    });

  });

  jQuery('[name=ppt-filter-type]').change(doFilter);
	jQuery('[name=ppt-status-recording]').change(doFilter)
  
  function doFilter() {
    var filters = [];
    jQuery.each(jQuery('.select2-presentation-filter').select2('data'), function(i, e) {
      filters.push(e.id);
    });

    jQuery('.sel2-filters').each(function(i, element) {
      jQuery.each(jQuery(element).select2('data'), function(i, e) {
        filters.push(e.id);
      });
    });

		if(jQuery('[name=ppt-status-recording]')[0].checked) {
			filters.push('filter-status-recording')
		}

		/* console.log({ filters }); */
		
		jQuery('.session-block').show();
		jQuery('.block-day').show();

    jQuery(".block-day").removeClass('hide-event').addClass('show-event');
    jQuery(".presentation-tile").removeClass('show-event').addClass('hide-event');
    if(filters.length === 0) {
      jQuery(".presentation-tile").removeClass('hide-event').addClass('show-event')
    /* } else if(filters.length === 1) {
      var e = ".presentation-tile." + filters[0];
      jQuery(e).show(); */
    } else if ("union" === jQuery("[name=ppt-filter-type]:checked").val()) {
      jQuery.each(filters, function(i, e) {
        jQuery(".presentation-tile." + e).removeClass('hide-event').addClass('show-event')
      })
    } else {
      var e = ".presentation-tile";
      jQuery.each(filters, function(i, f) {
        e += "." + f
      });
      jQuery(e).removeClass('hide-event').addClass('show-event')
    }

    var datesFiltered = [];
    jQuery('.sel2-filters.filter-special-dates').each(function(i, element) {
      jQuery.each(jQuery(element).select2('data'), function(i, e) {
        datesFiltered.push(e.id);
      });
		});
		
		jQuery.each(jQuery('.session-block'), function(i, e) {
			if(jQuery(e).find('.presentation-tile:visible').length === 0) {
				jQuery(e).hide();
			}
		});

		jQuery.each(jQuery('.block-day'), function(i, e) {
			if(jQuery(e).find('.session-block:visible').length === 0) {
				jQuery(e).hide();
			}
		});

    // if union, hide all dates which have no events
    // if intersecion, repeat above and also hide days not selected explicitly

    /* var days = [];
    jQuery.each(jQuery("[data-day]"), function(i, e) { days.push(jQuery(e).data('day')) })
    days = jQuery.unique(days);
    jQuery.each(days, function(i, d) {
      if(jQuery("[data-day=" + d + "].show-event").length == 0) {
        jQuery('.block-day-' + d).hide();
      }
    })

    if ("intersection" === jQuery("[name=ppt-filter-type]:checked").val() && datesFiltered.length > 0) {
      console.log(days, datesFiltered);
      jQuery.each(days, function(i, d) {
        if(datesFiltered.indexOf("filter-" + d) === -1) {
          jQuery(".block-day-" + d).hide()
        }
      })
    } */

  }
</script>

<?php get_footer(); ?>