<?php
/**
 * Template Name: Home page
 *
 * This is the template that displays all pages by default.
 * Please note that this is the WordPress construct of pages
 * and that other 'pages' on your WordPress site will use a
 * different template.
 *
 * @package understrap
 */

get_header();

$container   = get_theme_mod( 'understrap_container_type' );
$sidebar_pos = get_theme_mod( 'understrap_sidebar_position' );

while ( have_posts() ) : the_post();
?>
<div id="home">
  <div class="wrapper" id="page-wrapper">
  	<div class="<?php echo esc_html( $container ); ?>" id="content" tabindex="-1">
  		<div class="row">
  			<!-- Do the left sidebar check -->
  			<?php get_template_part( 'global-templates/left-sidebar-check', 'none' ); ?>
  			<main class="site-main" id="main">
  				<?php
            if( have_rows('home_slides') ) {
              ?>
              <div class="owl-carousel owl-theme home-carousel">
                <?php
                while ( have_rows('home_slides') ) : the_row();
                  // Your loop code
                  ?>
                  <div class="item text-center">
                    <br /><br /><br />
                    <h2><?php the_sub_field('title'); ?></h2>
                    <br />
                    <p><?php the_sub_field('description'); ?></p>
                    <br />
                    <a href="<?php the_sub_field('link'); ?>" class="btn btn-primary border-30">
                      <?php the_sub_field('button_text'); ?>
                    </a>
                  </div>
                  <?php
                endwhile;
                ?>
              </div>
              <?php
              }
              ?>
  			</main><!-- #main -->
  		</div><!-- #primary -->
  	</div><!-- .row -->

      <div class="row bg-orange">
        <?php
          $args = array(
            'posts_per_page'   => 3,
            'post_type'        => 'feature',
            'post_status'      => 'publish'
          );

        foreach( get_posts($args) as $post) {
          setup_postdata($post);
          ?>
          <div class="col-md-3 col-sm-6 bg-f7">
            <br />
            <h5><?php the_title(); ?></h5>
            <p><?php the_content(); ?></p>
          </div>
          <?php
          wp_reset_postdata();
        }
        ?>
        <div class="col-md-3 col-sm-6">
         <div id="view-all-features" class=" d-flex justify-content-center align-items-center">
           <a href="<?php echo get_post_type_archive_link("feature"); ?>"><?php
            echo WPGlobus::Config()->language === 'fr' ? 'Toutes les fonctionnalités' : 'All Features';
           ?></a>
         </div>
        </div>
      </div>

    </div><!-- Container end -->

  </div><!-- Wrapper end -->
</div>
<?php endwhile; // end of the loop. ?>

<?php get_template_part( 'loop-templates/content', 'pricing' ); ?>

<?php get_footer(); ?>
