<?php
/**
 * @package understrap
 */

get_header();

$container   = get_theme_mod( 'understrap_container_type' );
$sidebar_pos = get_theme_mod( 'understrap_sidebar_position' );
?>
<div class="wrapper" id="page-wrapper">

	<div class="<?php echo esc_html( $container ); ?>" id="content" tabindex="-1">

		<div class="row">

			<!-- Do the left sidebar check -->
			<?php get_template_part( 'global-templates/left-sidebar-check', 'none' ); ?>

			<main class="site-main" id="main">
				<div class="row">
					<?php
						$event_id = explode("-", $wp_query->query["name"])[0];

						$response = wp_remote_get( API_ENDPOINT . '/public-event/' . $event_id );
						$body = wp_remote_retrieve_body( $response );
						$json = json_decode($body);
						foreach($json->data as $event) {
							echo "<!-- Event Info";
							print_r($event);
							echo "-->";
							?>
								<div class="col-md-4 col-sm-6">
									<div style="padding: 20px; margin-bottom: 20px;" class="bg-white">
										<h4><?php echo $event->name; ?></h4>
										<a href="?event_id=<?php echo $event->_id; ?>">
											<div style="height: 200px; display: flex; align-items: center; justify-content: center;">
												<img src="<?php echo $event->logo; ?>" alt="<?php echo $event->name; ?>" class="img-responsive" style="max-height: 200px;">
											</div>
										</a>
										<b><?php echo $event->venue; ?></b><br />
										<?php
											echo date("dS M Y", strtotime($event->start));
											if( strtotime($event->start) != strtotime($event->end) ) {
												echo " to " . date("dS M Y", strtotime($event->end));
											}
										?>
									</div>
								</div>
							<?php
						}
					?>
				</div>
			</main><!-- #main -->
		</div><!-- #primary -->

		<!-- Do the right sidebar check -->
		<?php if ( 'right' === $sidebar_pos || 'both' === $sidebar_pos ) : ?>

			<?php get_sidebar( 'right' ); ?>

		<?php endif; ?>

	</div><!-- .row -->

</div><!-- Container end -->

</div><!-- Wrapper end -->

<?php get_template_part( 'loop-templates/content', 'pricing' ); ?>

<?php get_footer(); ?>
