jQuery('input[type="range"]').rangeslider({
  polyfill: false
});

function calculate() {
  var hours = jQuery("#input-calculator-hours").val(); // in hours
  jQuery("#output-calculator-hours").text( hours );
  jQuery("#output-calculator-plays").text( jQuery("#input-calculator-plays").val() );

  var storage = hours * 4; // in MB
  if (storage > 30) {
    storage -= 30;
  } else {
    storage = 0;
  }
  var plays = jQuery("#input-calculator-plays").val(); // count

  var total = ( hours * 7.2 ) + ( storage * 0.12 ) + ( plays / 10 );
  // console.log(hours * 7.2, storage * 0.12, plays / 10)
  jQuery("#output-pricing").text(total.toFixed(2));
}

jQuery(document).on('input', 'input[type="range"]', function() {
  calculate();
});

calculate();


/* Video player */

var t;
function hideControls() {
	if(_playing) {
		jQuery(".toolbar").fadeOut(100);
	}
}
function resetTimer() {
	jQuery(".toolbar").fadeIn(100);
	clearTimeout(t)
	t = setTimeout(hideControls, 1000 * 5)
}

// jQuery(".toolbar").fadeIn(100);

// jQuery(".player").live("mouseenter", function() {
//   if (_played_once) {
//     jQuery(".toolbar").fadeIn(100);
//   }
// })
// jQuery(".player").live("mouseleave", function() {
//   if (_played_once) {
//     jQuery(".toolbar").fadeOut(100);
//   }
// })

jQuery('.progress').slider({
  value: 0,
  orientation: "horizontal",
  range: "min",
  animate: true
});

var _duration = 0, _playing = false, _volume = 1, _fullscreen = false, _played_once = false, _setMax = false;

if (!Array.prototype.findIndex) {
  Object.defineProperty(Array.prototype, 'findIndex', {
    value: function(predicate) {
     // 1. Let O be ? ToObject(this value).
      if (this == null) {
        throw new TypeError('"this" is null or not defined');
      }

      var o = Object(this);

      // 2. Let len be ? ToLength(? Get(O, "length")).
      var len = o.length >>> 0;

      // 3. If IsCallable(predicate) is false, throw a TypeError exception.
      if (typeof predicate !== 'function') {
        throw new TypeError('predicate must be a function');
      }

      // 4. If thisArg was supplied, let T be thisArg; else let T be undefined.
      var thisArg = arguments[1];

      // 5. Let k be 0.
      var k = 0;

      // 6. Repeat, while k < len
      while (k < len) {
        // a. Let Pk be ! ToString(k).
        // b. Let kValue be ? Get(O, Pk).
        // c. Let testResult be ToBoolean(? Call(predicate, T, « kValue, k, O »)).
        // d. If testResult is true, return k.
        var kValue = o[k];
        if (predicate.call(thisArg, kValue, k, o)) {
          return k;
        }
        // e. Increase k by 1.
        k++;
      }

      // 7. Return -1.
      return -1;
    }
  });
}

jQuery(document).ready(function() {
  jQuery('.home-carousel').owlCarousel({
    items: 1,
    loop: true,
    nav: false,
    autoplay: true,
    autoplayTimeout: 5000
  });

  jQuery(".player").css("min-height", (( jQuery(".player").width() / 16 ) * 9))
  // console.log(__slides);

  if(jQuery("#video-iframe").length == 1) {
    var videoPlayer = new SV.Player({videoId: jQuery("#video-iframe").data("video")});

    videoPlayer.bind('ready', function(event){
      _duration = event.data.duration;
      jQuery(".progress").slider("option", "max", _duration);
    });

    var not_dragging = true;
    // var prev_slide = -1;
    videoPlayer.bind('progress', function(event) {
      // console.log(event.data.time)
      // console.log("Progress", event)
      var next_slide = __slides.findIndex(function(slide) {
        return slide.time > (event.data.time * 1000)
      })
      // console.log("next_slide: ", next_slide);
      // jQuery(".owl-item.center").removeClass("center");
      if(next_slide == -1) {
        // last slide
        const current = jQuery(".slides-summary .thumb:nth(" + (jQuery(".slides-summary .thumb").length - 1) + ")");
        if(!current.hasClass('.current')) {
          jQuery(".slides-summary .current").removeClass('current');
          current.addClass('current');
        }
      } else {
        if (not_dragging) {
          // thumb_carousel.trigger("to.owl.carousel", next_slide - 1)
          const current = jQuery(".slides-summary .thumb:nth(" + (next_slide - 1) + ")");
          if(!current.hasClass('.current')) {
            jQuery(".slides-summary .current").removeClass('current');
            current.addClass('current');
          }
        }
          // console.log("goto")
        // }
      }

      if(!_setMax && event.data.percent !== 0) {
        _setMax = true;
        jQuery('.progress').slider("option", "max", event.data.time / event.data.percent);
      }
      jQuery('.progress').slider("option", "value", (event.data.time));
    });

    videoPlayer.bind('pause', function(event) {
      _playing = false;
      jQuery('.play-pause i').removeClass('icon-pause').addClass('icon-play');
    });

    videoPlayer.bind('play', function(event) {
      _playing = true;
      if(!_played_once) {
        // First play, set up event listeners to hide or show thumbnails
        document.onmousemove = resetTimer;
        document.onmousedown = resetTimer;
      }
      _played_once = true;
      jQuery('.play-pause i').removeClass('icon-play').addClass('icon-pause');
    });

    videoPlayer.bind('volume', function(event) {
      _volume = event.data;
      if (_volume == 1) {
        jQuery('.volume i').removeClass('icon-volume-off').addClass('icon-volume-up');
      } else if (_volume == 0) {
        jQuery('.volume i').removeClass('icon-volume-up').addClass('icon-volume-off');
      }
    });

    jQuery('.play-pause a, #iframe-overlay').click(function(){
      console.log("click");
      if (!_playing) {
        videoPlayer.play();
      } else {
        videoPlayer.pause();
      }
    });

    jQuery('.volume a').click(function(){
      if (_volume == 0) {
        _volume = 1;
      } else {
        _volume = 0;
      }
      videoPlayer.setVolume(_volume);
    });

    jQuery('.fullscreen a').click(function(){
      var elem = jQuery('.player')[0];
      if (!_fullscreen) {
        if (elem.requestFullscreen) {
          elem.requestFullscreen();
        } else if (elem.mozRequestFullScreen) {
          elem.mozRequestFullScreen();
        } else if (elem.webkitRequestFullscreen) {
          elem.webkitRequestFullscreen();
        } else if (elem.msRequestFullscreen) {
          elem.msRequestFullscreen();
        }
        _fullscreen = true;
      } else {
        if (document.exitFullscreen) {
          document.exitFullscreen();
        } else if (document.mozCancelFullScreen) {
          document.mozCancelFullScreen();
        } else if (document.webkitCancelFullScreen) {
          document.webkitCancelFullScreen();
        } else if (document.msExitFullscreen) {
          document.msExitFullscreen();
        }
        _fullscreen = false;
      }
    });

    jQuery('.progress').slider({
      value: 0,
      orientation: "horizontal",
      range: "min",
      animate: true,
      slide: function(event, ui) {
        videoPlayer.seek(ui.value);
      }
    });

    jQuery(".slides-summary .item").click(function() {
      // console.log("Seeked thumbnial")
      const time = Math.round(jQuery(this).data("time") / 1000);
      if(!_played_once) {
        videoPlayer.play();
        setTimeout(function(){
          videoPlayer.seek(time)
        }, 400);
      } else {
        videoPlayer.seek(time)
      }
    })

    jQuery(".video-prev-slide").click(function() {
      jQuery(".slides-summary .current").prev().find(".item").trigger('click');
    })

    jQuery(".video-next-slide").click(function() {
      jQuery(".slides-summary .current").next().find(".item").trigger('click');
    })
    // videoPlayer.seek(ui.value)

    // var thumb_carousel = jQuery(".video-slides").owlCarousel({
    //   center: true,
    //   // items: 5,
    //   autoWidth: true,
    //   nav: false,
    //   loop: true,
    //   dots: false,
    //   margin: 10,
    //   mouseDrag: true,
    //   touchDrag: true,
    //   pullDrag: true,
    //   onDrag: function(event) {
    //     not_dragging = false;
    //   },
    //   onDragged: function(event) {
    //     var time = jQuery(".owl-item.center .item").data("time");
    //     videoPlayer.seek(Math.round(time / 1000))
    //     not_dragging = true;
    //   }
    // });
  }

});

function filterPresentations() {
  var filters = [];
  jQuery.each(jQuery("[name=presentation-filter]:checked"), function(i, e) {
    filters.push(e.value)
  })
  jQuery(".presentation-tile").hide();
  if(filters.length == 0) {
    jQuery(".presentation-tile").show();
  } else {
    if(jQuery("[name=presentation-filter-type]:checked").val() == "union") {
      // Union
      jQuery.each(filters, function(i, f) {
        jQuery(".presentation-tile." + f).show();
      })
    } else {
      // Intersection
      var filter = ".presentation-tile";
      jQuery.each(filters, function(i, f) {
        filter += "." + f
      })
      jQuery(filter).show();
    }
  }
}

jQuery("[name=presentation-filter]").change(filterPresentations)
jQuery("[name=presentation-filter-type]").change(filterPresentations)

var specialElementHandlers = {

}

jQuery("#download-pdf").click(function() {
  var doc = new jsPDF()
  doc.fromHTML(jQuery('#schedule-content').get(0), 15, 15, {
    'width': 170, 
    'elementHandlers': specialElementHandlers
  }, function (dispose) {
    doc.save('sample-file.pdf');
  });
  return false
})



jQuery(function () {
  jQuery('[data-toggle="tooltip"]').tooltip()
})

jQuery.each(jQuery(".schedule-day"), function(index, dayData) {
  var sorted = jQuery(dayData).children().sort(function (a, b) {
    var contentA =parseInt( jQuery(a).data('time'));
    var contentB =parseInt( jQuery(b).data('time'));
    return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
  });
  jQuery(dayData).html(sorted);
})

jQuery(function () {
  jQuery('.ellipses-lines-1').ellipsis({ lines: 1 });
  jQuery('.ellipses-lines-2').ellipsis({ lines: 2 });
  jQuery('.ellipses-lines-3').ellipsis({ lines: 3 });
  jQuery('.ellipses-lines-4').ellipsis({ lines: 4 });
  jQuery('.ellipses-lines-5').ellipsis({ lines: 5 });
});

// jQuery('.ellipses-lines-2').ellipsis({
//   lines: 2,             // force ellipsis after a certain number of lines. Default is 'auto'
//   // ellipClass: 'ellip',  // class used for ellipsis wrapper and to namespace ellip line
//   // responsive: true      // set to true if you want ellipsis to update on window resize. Default is false
// });

// jQuery('.ellipses-lines-3').ellipsis({
//   lines: 3,             // force ellipsis after a certain number of lines. Default is 'auto'
//   // ellipClass: 'ellip',  // class used for ellipsis wrapper and to namespace ellip line
//   // responsive: true      // set to true if you want ellipsis to update on window resize. Default is false
// });

// jQuery('.ellipses-lines-4').ellipsis({
//   lines: 4,             // force ellipsis after a certain number of lines. Default is 'auto'
//   // ellipClass: 'ellip',  // class used for ellipsis wrapper and to namespace ellip line
//   // responsive: true      // set to true if you want ellipsis to update on window resize. Default is false
// });

// jQuery('.ellipses-lines-5').ellipsis({
//   lines: 5,             // force ellipsis after a certain number of lines. Default is 'auto'
//   // ellipClass: 'ellip',  // class used for ellipsis wrapper and to namespace ellip line
//   // responsive: true      // set to true if you want ellipsis to update on window resize. Default is false
// });

// jQuery('.ellipses-lines-6').ellipsis({
//   lines: 6,             // force ellipsis after a certain number of lines. Default is 'auto'
//   // ellipClass: 'ellip',  // class used for ellipsis wrapper and to namespace ellip line
//   // responsive: true      // set to true if you want ellipsis to update on window resize. Default is false
// });

jQuery(function () {
  jQuery('[data-toggle="popover"]').popover();
});

// jQuery(function() {
//   return jQuery(".stick-header").stick_in_parent({
//     parent: ".event-tile-container"
//   });
// });

// jQuery(window).on("resize", (function(_this) {
//   return function(e) {
//     return jQuery(document.body).trigger("sticky_kit:recalc");
//   };
// })(this));

// // The fix:

// // side = 'left' or 'right'
// var fixHScroll = function($el, side) {
//   var $sidebar = $el;
//   var $parent = $el.parent()[0];

//   jQuery('.event-tile-container').on('scroll', function() {
//     if ($el.css('position') === 'fixed') {
//       $el.css(side, $parent.getBoundingClientRect()[side]);
//     } else {
//       $el.css(side, 'initial');
//     }
//   });
// };

// fixHScroll(jQuery('.stick-header'), 'left');

  // var target = jQuery(".timeline-container");
// jQuery(".event-tile-container").scroll(function() {
//   if (this.scrollTop === 0) {
//     jQuery(this).siblings('.timeline-container')
//     .prop("scrollTop", 0)
//     .prop("scrollLeft", this.scrollLeft);
//   } else {
//     jQuery(this).siblings('.timeline-container')
//     .prop("scrollTop", this.scrollTop + 140)
//     .prop("scrollLeft", this.scrollLeft);
//   }
// });



// var mouseposition = "";

// jQuery(".event-tile-container").mouseenter(function() {
//   mouseposition = ".event-tile-container";
// });
// jQuery(".timeline-container").mouseenter(function() {
//   mouseposition = ".timeline-container";
// });

// const dependantScroll = [".event-tile-container", ".timeline-container"];

// jQuery(".event-tile-container, .timeline-container").scroll(function(event) {
//   var scrollSibling = dependantScroll[0] === mouseposition ? dependantScroll[1] : dependantScroll[0];
//   jQuery(this).siblings(scrollSibling)
//     .prop("scrollTop", this.scrollTop)
//     .prop("scrollLeft", this.scrollLeft);
// });



// $(".stick-header").stick_in_parent();
// $(".schedule-date").stick_in_parent();

// a helper variable
// jQuery(document).ready(function(){
//   var timeout;

//   jQuery('.timeline-container, .event-tile-container').on("scroll", function callback() {
//       // clear the 'timeout' every 'scroll' event call
//       // to prevent re-assign 'scroll' event to other element
//       // before finished scrolling
//       clearTimeout(timeout);

//       // get the used elements
//       var source = jQuery(this),
//           target = jQuery(source.is(".timeline-container") ? '.event-tile-container' : '.timeline-container');

//       // remove the callback from the other 'div' and set the 'scrollTop'
//       target.off("scroll").scrollTop(source.scrollTop());

//       // create a new 'timeout' and reassign 'scroll' event
//       // to other 'div' on 100ms after the last event call
//       timeout = setTimeout(function() {
//           target.on("scroll", callback);
//       }, 100);
//   });
// })
